package com.link.core.basic.limiter;

import com.link.core.cache.MethodAnnotationPointcutAdvisor;
import javax.annotation.Resource;
import org.springframework.aop.support.AbstractPointcutAdvisor;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class LinkRateLimiterConfig {
   @Resource
   private LinkRateLimiterConfigure linkRateLimiterConfigure;

   @Bean
   @ConditionalOnMissingBean({LinkRateLimiterHandler.class})
   public LinkRateLimiterHandler linkRateLimiterHandler() {
      LinkRateLimiterHandler linkRateLimiterHandler = new LinkRateLimiterHandler(this.linkRateLimiterConfigure);
      return linkRateLimiterHandler;
   }

   @Bean
   @ConditionalOnBean({LinkRateLimiterHandler.class})
   public LinkRateLimiterInterceptor linkRateLimiterInterceptor(LinkRateLimiterHandler linkRateLimiterHandler) {
      return new LinkRateLimiterInterceptor(linkRateLimiterHandler);
   }

   @Bean({"limiterAdvisor"})
   @ConditionalOnBean({LinkRateLimiterInterceptor.class})
   public AbstractPointcutAdvisor linkRateLimiterAdvisor(LinkRateLimiterInterceptor linkRateLimiterInterceptor) {
      AbstractPointcutAdvisor linkRateLimiterAdvisor = new MethodAnnotationPointcutAdvisor(LinkRateLimiter.class, linkRateLimiterInterceptor);
      linkRateLimiterAdvisor.setOrder(this.linkRateLimiterConfigure.getLimiterOrder());
      return linkRateLimiterAdvisor;
   }
}
